import cloneDeep from 'lodash/cloneDeep';
import { ToProtoType } from './extends/proto';
export class ProToReversed extends ToProtoType {
    constructor(self = [Array]) {
        super();
        this.selfs = self;
    }
    get _name() {
        return 'toReversed';
    }
    setup() {
        const newArr = [];
        // @ts-ignore
        let index = this.length;
        while (index) {
            index--;
            // @ts-ignore
            newArr.push(this[index]);
        }
        return newArr;
    }
}
export class ProToSorted extends ToProtoType {
    constructor(self = [Array]) {
        super();
        this.selfs = self;
    }
    get _name() {
        return 'toSorted';
    }
    setup(...arg) {
        // @ts-ignore
        const newArr = cloneDeep(this);
        // @ts-ignore
        return newArr.sort(...arg);
    }
}
export class ProToSpliced extends ToProtoType {
    constructor(self = [Array]) {
        super();
        this.selfs = self;
    }
    get _name() {
        return 'toSpliced';
    }
    setup(...arg) {
        const newArr = cloneDeep(this);
        newArr.splice(...arg);
        return newArr;
    }
}
export class ProtoArray {
    static install(self, warn) {
        new ProToReversed(self).install(warn);
        new ProToSorted(self).install(warn);
        new ProToSpliced(self).install(warn);
    }
}
