import { ToProtoType } from './extends/proto';
export class PromiseLotusRoot extends ToProtoType {
    constructor(self = [Function]) {
        super();
        this.selfs = self;
    }
    get _name() {
        return 'toPromised';
    }
    setup(...args) {
        return new Promise(async (resolve, reject) => {
            let _result;
            let _carg = [];
            const newArgs = args.map(arg => {
                if (arg === '$func') {
                    return async function (...carg) {
                        _carg.push(carg);
                    };
                }
                return arg;
            });
            try {
                _result = await this.apply(this, newArgs);
                resolve([..._carg, _result]);
            }
            catch (err) {
                reject(err);
            }
        });
    }
}
